/*
 * This source file is part of KEOS (Free 3D Engine)
 * For the latest info, see http://www.keosengine.org/
 * E-mails : thierry.vouriot@keosengine.org, yeri@keosengine.org
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA, or go to
 * http://www.gnu.org/copyleft/lesser.txt.
 *
 */
#include "KeosOGLTexture.h"
#include "KeosOGLEnum.h"
#include "KeosOGLRenderSystem.h"
#include "KeosPixelUtils.h"
#include "KeosRectangle.h"

namespace Keos
{
    //=======================================================================
    // COGLTexture implementation
    //=======================================================================

    //-----------------------------------------------------------------------
    COGLTexture::COGLTexture(const TVector2I& Size, TPixelFormat Format, bool bHasMipmaps, bool bAutoMipmaps, uint nTexture) :
    ITextureBase(Size, Format, bHasMipmaps, bAutoMipmaps),
    m_nTexture   (nTexture)
    {

    }

    //-----------------------------------------------------------------------
    COGLTexture::~COGLTexture()
    {
        if (m_nTexture)
            glDeleteTextures(1, &m_nTexture);
    }

    //-----------------------------------------------------------------------
    uint COGLTexture::GetOGLTexture() const
    {
        return m_nTexture;
    }

    //-----------------------------------------------------------------------
    void COGLTexture::Update(const CRectangle& Rect)
    {
        Assert(CRectangle(0, 0, m_Size.x, m_Size.y).Intersects(Rect) == INT_IN);

        // Get the formats of pixels of the texture and the image
        COGLEnum::TPixelFmt TexFmt = COGLEnum::Get(m_Format);
        COGLEnum::TPixelFmt ImgFmt = COGLEnum::Get(m_Data.GetFormat());

        // Activation of the current texture
        glBindTexture(GL_TEXTURE_2D, m_nTexture);

        // Update pixels of the texture
        if (FormatCompressed(m_Data.GetFormat()))
        {
            // Format de pixel compressé - on utilise une extension pour uploader les pixels
            ulong DataSize = Rect.Width() * Rect.Height() * GetBytesPerPixel(m_Data.GetFormat());
            if (Rect.Width() == m_Size.x && Rect.Height() == m_Size.y)
            {
                COGLRenderSystem::glCompressedTexSubImage2DARB(GL_TEXTURE_2D, 0, Rect.Left(), Rect.Top(), Rect.Width(), Rect.Height(), ImgFmt.Format, DataSize, m_Data.GetData());
            }
            else
            {
                CImage SubData = m_Data.SubImage(Rect);
                COGLRenderSystem::glCompressedTexSubImage2DARB(GL_TEXTURE_2D, 0, Rect.Left(), Rect.Top(), Rect.Width(), Rect.Height(), ImgFmt.Format, DataSize, SubData.GetData());
            }
        }
        else
        {
            if (!m_bHasMipmaps || m_bAutoMipmaps)
            {
                if ((Rect.Width() == m_Size.x) && (Rect.Height() == m_Size.y))
                {
                    glTexSubImage2D(GL_TEXTURE_2D, 0, Rect.Left(), Rect.Top(), Rect.Width(), Rect.Height(), ImgFmt.Format, ImgFmt.Type, m_Data.GetData());
                }
                else
                {
                    CImage SubData = m_Data.SubImage(Rect);
                    glTexSubImage2D(GL_TEXTURE_2D, 0, Rect.Left(), Rect.Top(), Rect.Width(), Rect.Height(), ImgFmt.Format, ImgFmt.Type, SubData.GetData());
                }
            }
            else
            {
                gluBuild2DMipmaps(GL_TEXTURE_2D, TexFmt.Internal, m_Size.x, m_Size.y, ImgFmt.Format, ImgFmt.Type, m_Data.GetData());
            }
        }

        // Deactivation of the texture
        glBindTexture(GL_TEXTURE_2D, 0);
    }

} // namespace Keos
